<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
    <con:xquery>xquery version "1.0" encoding "UTF-8";

declare namespace xf = "http://genericparallel/split";

declare function xf:splitIntoBatches($requests as element(*), $maxParallel as xs:positiveInteger) as element() {
	
	&lt;Batches>    
		{
	    let $elsize := count($requests/*)
	    
	    let $num := fn:ceiling($elsize div $maxParallel) cast as xs:positiveInteger
	    
		for $idx in 1 to $num
		let $startPos := ($idx - 1) * $maxParallel + 1 
		let $endPos := $idx * $maxParallel
		return 
	        &lt;Batch> 
	        {
	        	$requests/*[fn:position() = ($startPos to $endPos)]
	        }
	        &lt;/Batch>
	    }
	&lt;/Batches>
};

declare variable $requests as element(*) external;
declare variable $maxParallel as xs:positiveInteger external;

xf:splitIntoBatches($requests, $maxParallel)</con:xquery>
</con:xqueryEntry>